#include <stdio.h>
#include "debugprint.h"
#include "blst/blst.h"

void print_bytes(const char* label, byte *toprint, int length){
    printf("%s", label);
    for(int i=0;i<length;i++){
        printf("%.2x ", toprint[i]);
    }
    printf("\n");
}

void debug_print_bytes(__attribute__((unused)) const char* label, __attribute__((unused)) byte *toprint, __attribute__((unused)) int length){
    #ifdef INSECURE_CTM_DEBUG_PRINT
    print_bytes(label, toprint, length);
    #endif
}

void print_scalar(const char* label, blst_scalar *toprint){
    byte temp_buffer[32];
    blst_bendian_from_scalar(temp_buffer, toprint);

    debug_print_bytes(label, temp_buffer, 32);
}

void debug_print_scalar(__attribute__((unused)) const char* label, __attribute__((unused)) blst_scalar *toprint){
    #ifdef INSECURE_CTM_DEBUG_PRINT
    print_scalar(label, toprint);
    #endif
}